module.exports = {
  create: {
    requestBody: [
      "!mobile",
      "!password",
      "!province",
      "!city",
      "!set",
      "pay_type",
      "!name",
      "id_card",
      "level",
      "points",
      "recommend",
      "r_mobile",
      "wxaccount",
      "create_time",
    ],
  },
  destroy: {
    params: ["!id"],
    service: "delete",
  },
  update: {
    params: ["!id"],
    requestBody: [
      "!mobile",
      "!password",
      "!province",
      "!city",
      "!set",
      "pay_type",
      "!name",
      "id_card",
      "level",
      "points",
      "recommend",
      "r_mobile",
      "wxaccount",
      "create_time",
    ],
  },
  show: {
    parameters: {
      params: ["!id"],
    },
    service: "fetch",
  },
  index: {
    parameters: {
      query: {
        mobile: "mobile",
        province: "province",
        city: "city",
        pay_type: "pay_type",
        name: "name",
        id_card: "id_card",
        level: "level",
        recommend: "%recommend%",
        r_mobile: "r_mobile",
        car_show: "car_show",
        stockholder: "stockholder",
        wxaccount: "%wxaccount%",
        set: "set",
        status: "status",
        "create_time@start": "create_time@start",
        "create_time@end": "create_time@end",
      },
    },
    service: "query",
    options: {
      query: ["skip", "limit"],
      sort: ["meta.createdAt"],
      desc: true,
      count: true,
    },
  },
  // 修改密码
  passwd: {
    params: ["!id"],
    requestBody: ["!password"],
    service: "passwd",
  },

  group: {
    parameters: {
      query: {
        r_mobile: "r_mobile",
        province: "province",
        set: "set",
        "create_time@start": "create_time@start",
        "create_time@end": "create_time@end",
      },
    },
    service: "group",
    options: {
      query: ["skip", "limit"],
      sort: ["meta.createdAt"],
      desc: true,
      // count: true,
    },
  },
  // 用户审核
  check: {
    params: ["!id"],
    requestBody: ["!status"],
    service: "check",
  },
};
