module.exports = {
  create: {
    requestBody: ["mobile", "name", "points", "opera", "remark"],
  },
  destroy: {
    params: ["!id"],
    service: "delete",
  },
  update: {
    params: ["!id"],
    requestBody: ["mobile", "name", "points", "opera", "remark"],
  },
  show: {
    parameters: {
      params: ["!id"],
    },
    service: "fetch",
  },
  index: {
    parameters: {
      query: {
        mobile: "mobile",
        name: "%name%",
        points: "points",
        opera: "opera",
        "create_time@start": "create_time@start",
        "create_time@end": "create_time@end",
      },
    },
    service: "query",
    options: {
      query: ["skip", "limit"],
      sort: ["meta.createdAt"],
      desc: true,
      count: true,
    },
  },
};
