module.exports = {
  create: {
    requestBody: ["name", "code", "pcode", "disabled", "remark"],
  },
  destroy: {
    params: ["!id"],
    service: "delete",
  },
  update: {
    params: ["!id"],
    requestBody: ["name", "code", "pcode", "disabled", "remark"],
  },
  show: {
    parameters: {
      params: ["!id"],
    },
    service: "fetch",
  },
  index: {
    parameters: {
      query: {
        name: "%name%",
        code: "code",
        pcode: "pcode",
        disabled: "disabled",
        remark: "remark",
        "create_time@start": "create_time@start",
        "create_time@end": "create_time@end",
      },
    },
    service: "query",
    options: {
      query: ["skip", "limit"],
      sort: ['code'],
      asc: true,
      count: true,
    },
  },
};
